#
# perl ana.pl <snmp-logfile>  > <analyzed-log>
#


use Text::ParseWords;
use Socket;

$filename = $ARGV[0];


sub my_gethostbyaddr
{
  my $ipaddr = $_[0];

  if ($hnames{$ipaddr} eq undef) {
    $hname = gethostbyaddr($ipaddr, AF_INET);
    if ($hname eq undef) {
      $hname = inet_ntoa($ipaddr);
    }
    $hnames{$ipaddr} = $hname;
  }
  return $hnames{$ipaddr};
}


open(FILE, "< $filename") or die "Can't open `$filename': $!";

while (<FILE>) {
  #
  # Data format
  #
  #
  #

  #
  # split a line into columns
  #
  @words = &parse_line(" ", 0, $_);
  for ($i = 0; $i < $#words; $i++) {
#    printf("[%s] ",  $words[$i]);
  }
#  printf("\n");

  #
  # get datacol, strip trailing \n from datacol
  #
  # XXX: parse_line above strips double-quotes but never strips
  # newline (\n).  this is funny, but Perl is funny all by itself!
  # put back \n-stripped data to $words[3].

  $datacol = $words[3];
  $datacol =~ s/\n$//;
  $words[3] = $datacol;

  #
  # split $words[3] into @data
  #
  @data = &parse_line(" ", 0, $datacol);
#  printf("%s", $datacol);

  if (substr($data[0], 0, 1) eq "\@") {
    #
    # in/out data
    #
    if ((substr($data[0], 0, 3) eq "\@in") ||
        (substr($data[0], 0, 4) eq "\@out")) {
      $iaddr = inet_aton($data[1]);

      $src_name = my_gethostbyaddr($iaddr, AF_INET);
      if ($src_name eq undef) { $src_name = $data[1]; }
      $dst_pname = getservbyport($data[4], "tcp");
      if ($dst_pname eq undef) { $dst_pname = $data[4]; }

      printf("%s %s %s \"%s %s %s %s %s\"\n",
             $words[0], $words[1], $words[2],
             $data[0], $src_name, $data[2], $data[3], $dst_pname);
    }
  } else {
    #
    # system messages?
    # prepend the message with "=="
    #
    printf("%s %s %s \"==%s\"\n",
	   $words[0], $words[1], $words[2],
           $words[3]);
  }
  
}

close(FILE);
